# -----------------------------------------------------------------------------
package IDM_Template;
# -----------------------------------------------------------------------------

use strict;
use Log;

# -----------------------------------------------------------------------------
# -- NEW :
# -----------------------------------------------------------------------------

# --

sub new() {
    my $class  = shift;
    my $config = shift;    
    my $self   = { };

    bless($self, $class);

    $self->new_template();

    return $self;
  }


# -----------------------------------------------------------------------------
# --

sub wen() {
    my $self = shift;

  }

# -----------------------------------------------------------------------------
# --


sub new_template() {
    my $self   = shift;
    my %args   = @_;

    unless (defined $args{CLASS}) {
        die "\n\n new_template :  CLASS undefined! \n\n";
      }

    unless (defined $args{SIDSCONFIG}) {
        die "\n\n " . $args{CLASS} . "::new_template :  SIDSCONFIG undefined! \n\n";
      }

    unless (defined $args{MODSCONF}) {
        die "\n\n " . $args{CLASS} . "::new_template :  MODSCONF undefined! \n\n";
      }

    unless (defined $args{LAST_RUN_TIME}) {
        $args{LAST_RUN_TIME} = 0;
      }

        # ...LAST_RUN_TIME :
        #
        #    At what time/date did we last run?  Initialise to something
        #    really old, e.g., Unix Time (1970 Jan 01), i.e. 0, so that
        #    will always run immediately the first time...

    $self->{CLASS}         = $args{CLASS};
    $self->{SIDSCONFIG}    = $args{SIDSCONFIG};
    $self->{MODSCONF}      = $args{MODSCONF};
    $self->{DEBUGMODE}     = $args{MODSCONF}->module_debugmode($self->{CLASS});
    $self->{SLEEP_TIME}    = $args{SIDSCONFIG}->sleep_time();
    $self->{LAST_RUN_TIME} = $args{LAST_RUN_TIME};

    $self->{LOG} = Log->new(PREFIX    => $self->{CLASS}, 
                            MODULE    => $self->{CLASS},
                            MODSCFG   => $self->{MODSCONF},
                            BUFFERED  => "no",
                            ROOT_DIR  => $args{SIDSCONFIG}->root_dir(),
                            OWNER_UID => $args{SIDSCONFIG}->log_owner_uid(),
                            OWNER_GID => $args{SIDSCONFIG}->log_owner_gid);
  }


# -----------------------------------------------------------------------------
# -- DEBUG : 
# -----------------------------------------------------------------------------


    # ...print always, sometimes and rarely...


sub echo() {
    my $self = shift;
    my $text = shift;

    print $text;
 }


sub debug() {
    my $self = shift;
    my $text = shift;

    if (defined $text) {
        if (($self->{DEBUGMODE} eq "debug_verbose") || ($self->{DEBUGMODE} eq "debug")) {
            print $text;
          }
      }
    else {
        if (($self->{DEBUGMODE} eq "debug_verbose") || ($self->{DEBUGMODE} eq "debug")) {
            return 1;
          }
        else {  return 0;  }
      }
  }


sub debug_verbose() {
    my $self = shift;
    my $text = shift;

    if ($self->{DEBUGMODE} eq "debug_verbose") {
        print $text;
      }
    else {
        if ($self->{DEBUGMODE} eq "debug_verbose") {
            return 1;
          }
        else {  return 0;  }
      }
  }


# -----------------------------------------------------------------------------
# -- RUN : 
# -----------------------------------------------------------------------------

sub run_template() {
    my $self = shift;
    my $sids = shift;

    print "\n\n Hello from " . $self->{CLASS} . "...";

    $self->{LAST_RUN_TIME} = time;

    $self->{LOG}->append("");
    $self->{LOG}->append("==============================================================================");
    $self->{LOG}->append($sids->date_time() . " :: ");
    $self->{LOG}->append("==============================================================================");
    $self->{LOG}->append("");
  }


# -----------------------------------------------------------------------------
# -- Is it time for us to do our thing yet?

sub time_to_run() {
    my $self = shift;

    my ($seconds, $minutes, $hours,  
        $day_o_m, $month, $year, undef, undef, undef) = localtime(time);

    $year  += 1900;
    $month += 1;

    print "\n\n Checking time to run for: " . $self->{CLASS};
    print "\n     current time     : $year/$month/$day_o_m $hours:$minutes:$seconds";

    ($seconds, $minutes, $hours,  
        $day_o_m, $month, $year, undef, undef, undef) = localtime($self->{LAST_RUN_TIME});

    $year  += 1900;
    $month += 1;

    print "\n     last run time    : $year/$month/$day_o_m $hours:$minutes:$seconds";
    print "\n     module period    : " 
                            . $self->{MODSCONF}->module_period($self->{CLASS});
    print "\n     Sid's sleep time : " . $self->{SLEEP_TIME};

    # -- is time elapsed since last run greater than Sid's minimum time
    #    and also period given for module :

    if (    (time - $self->{LAST_RUN_TIME} >= $self->{SLEEP_TIME}) 
         && (time - $self->{LAST_RUN_TIME} >= 
                           $self->{MODSCONF}->module_period($self->{CLASS}))) {
        print "\n     Time to run!";
        return 1;
      }
    else {
        print "\n     Time for zzz...";
        return 0;
      }
  }


# -----------------------------------------------------------------------------
# -- Do our thing :

sub run() {
    my $self = shift;

    print "\n\n Hello from IDM_Template::run... \n Shouldn't you have "
	. "overridden me with your own subroutine? \n\n";

    $self->{LAST_RUN_TIME} = time;
  }



# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
