# -----------------------------------------------------------------------------
package SID_Config;
# -----------------------------------------------------------------------------

use strict;


# -----------------------------------------------------------------------------
# -- constructor :

sub new() {
    my $class = shift;
    my $self  = { SLEEP_TIME => 5,
                  @_ };

    unless ($self->{SLEEP_TIME} =~ m/^\d+$/) {
        die "\n\n SID_Config::new : SLEEP_TIME not sensible! \n\n";
      }

    bless($self, $class);

    return $self;
  }


# -----------------------------------------------------------------------------
# -- where am I installed and who should own the logs?

sub root_dir() {
    my $self = shift;
    return "/users/simonh/src/_sids/";
  }

sub log_owner_uid() {
    my $self = shift;
    return 1002;
  }

sub log_owner_gid() {
    my $self = shift;
    return 100;
  }


# -----------------------------------------------------------------------------
#--

sub hostname() {
    my $self = shift;
    return "man2.nw-grid.ac.uk";
  }



# -----------------------------------------------------------------------------
# -- Solaris 7, 9, 9, ..., RedHat 7.2, 8, 9, ... :

sub platform() {
    my $self = shift;

##  return "Solaris_7";
    return "OpenSuSE_9.3";
  }


# -----------------------------------------------------------------------------
# -- how many second to sleep for between runs :

sub sleep_time() {
    my $self = shift;

    return $self->{SLEEP_TIME};
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
