# -----------------------------------------------------------------------------
package Netstat;
    #
    # ...the CPAN Net::Netstat Wrapper module does not work on Solaris 
    #    so we build our own...
    #
    #     -- pls ensure this module works with your version of netstat:
    #         -- it is likely that either the Solaris or OpenSuSE formats
    #            will work for you --- if not, add another!
    #
# -----------------------------------------------------------------------------

use strict;

# -----------------------------------------------------------------------------


sub new() {
    my $class = shift;
    my %args  = @_;
    my $self  = { };

    unless (defined $args{PFORM}) {
        die "\n\n Netstat::new :  PFORM undefined \n\n";
      }

###    unless (defined $args{PROTO}) {
###        die "\n\n Netstat::new :  PROTO undefined \n\n";
###      }

###    unless (($args{PROTO} eq "TCP") || ($args{PROTO} eq "UDP")) {
###        die "\n\n Netstat::new :  PROTO bot TCP/UDP :  $args{PROTO} \n\n";
###      }

    bless($self, $class);

###    $self->{PROTO} = $args{PROTO};

    if ($args{PFORM} eq "Solaris_7") {
###        my $proto   = lc($args{PROTO});
###        my @netstat = `/usr/bin/netstat -P $proto`;
        my @netstat = `/usr/bin/netstat -P tcp`;

        $self->{CONNS} = [ ];

        foreach my $n (@netstat) {
            unless ($n =~ m/^([a-zA-Z0-9-]+\.)+[0-9]+\s+   # ...localhost.port
                             ([a-zA-Z0-9-]+\.)+[0-9]+\s+   #    remotehost.port
                             \d+\s+\d+\s+\d+\s+\d+\s+      #    shite
                             [A-Z]+$                       #    state
                           /x) {  
                print "\n What the fuck is this:: $n ???";
                next;
              }

            my $c = { };

            my ($loc, $rem, undef, undef, undef, 
                                          undef, $state) = split( /\s+/, $n);

            $c->{LOCAL_HOST}  = $loc;
            $c->{LOCAL_PORT}  = $loc;
            $c->{REMOTE_HOST} = $rem;
            $c->{REMOTE_PORT} = $rem;

            $c->{LOCAL_HOST}  =~ s/\.[a-zA-Z0-9\-]+$//;
            $c->{REMOTE_HOST} =~ s/\.[a-zA-Z0-9\-]+$//;
            $c->{LOCAL_PORT}  =~ s/([a-zA-Z0-9\-]+\.)+//;
            $c->{REMOTE_PORT} =~ s/([a-zA-Z0-9\-]+\.)+//;

            $c->{STATE} = $state;

            push(@{$self->{CONNS}}, $c);
          }
      }
    elsif ($args{PFORM} eq "OpenSuSE_9.3") {
###        my $proto   = lc($args{PROTO});
###        my @netstat = `/users/simonh/bin/netstat.static --$proto`;
        my @netstat = `/users/simonh/bin/netstat.static --tcp --udp`;

        $self->{CONNS} = [ ];

        foreach my $n (@netstat) {
            unless ($n =~ m/^[tu][cd]p\s+[01]\s+[01]\s+
                             ([a-z0-9-]+\.)+([a-z0-9-]+)?\:[a-z0-9]+\s+
                                                           # ...localhost.port
                             ([a-z0-9-]+\.)+([a-z0-9-]+)?\:[a-z0-9]+\s+
                                                           #    remotehost.port
                             [A-Z]+\s+$                       #    state
                           /x) {  next;  }

            my $c = { };

            my (undef, undef, undef, $loc, $rem, $state) = split( /\s+/, $n);

            ($c->{LOCAL_HOST},  $c->{LOCAL_PORT})  = split(/\:/, $loc);
            ($c->{REMOTE_HOST}, $c->{REMOTE_PORT}) = split(/\:/, $rem);

            $c->{STATE} = $state;

            push(@{$self->{CONNS}}, $c);
          }
      }
    else {
        die "\n\n Netstat::new UNKOWN PFORM: $args{PFORM} \n\n";
      }


    return $self;

  }


# -----------------------------------------------------------------------------
# -- READ METHODS :
# -----------------------------------------------------------------------------


sub connections() {
    my $self = shift;

    return $self->{CONNS};
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
